#!/bin/sh
# run the dedup estimate, then if ok, the migration, limited to 30 minutes
# 07/12/2017 acress - additional messages to stdout for command-line
BPDIR=/usr/bp
eval `grep BPDIR /etc/default/bp.ini`
sdir=$BPDIR/bpinit
timeoutbin=$BPDIR/bin/timeouts
timeoutval=1800
estlog=/var/log/unitrends-dedupchk.log
miglog=/var/log/migrate_nt2db.sh.log
instlog=/var/log/install-rr.log
metautil=$BPDIR/bin/metadataUtil
bputil=$BPDIR/bin/bputil
outf=/tmp/dedup_out.tmp

upload_log() {
    logf=$1
    full_model=$(cat /etc/unitrends-asset)
    log_date=$(date +%m%d%y_%H%M)
    log_name=${full_model}_${log_date}
    ftp_loc="ftp://ftp.unitrends.com/incoming/dedupconvLogs"

    curl -s -T ${logf} ${ftp_loc}/${log_name} --user anonymous:
}

$sdir/dedup_estimate.sh rpm
if [ $? -eq 5 ]; then
   lockFile=/var/lock/migrate_nt2db.sh-lock 
   MetadataDirectory=$($bputil -g fileDedup "MetadataDirectory" "" $BPDIR/bpinit/master.ini)
   lockBits=1
   lfile=$MetadataDirectory/metadataLock
   if [ "$MetadataDirectory" != "" ] && [ -f $lfile ]; then
     lockBits=$(stat --format=%s $lfile)
   fi
   echo "Starting migrate_nt2db on `date`" |tee -a $outf
   tail -n1 $estlog >>$outf
   if (( (lockBits & 0x1) != 0 )); then
       $metautil --unlock >> $miglog 2>&1
   fi
   $timeoutbin -t $timeoutval -d10 $sdir/migrate_nt2db.sh -r >>$outf 2>&1
   rv=$?
   pids=`ps -ef|grep "$sdir/migrate_nt2db.sh" |grep -v grep |awk '{ print $2 }'`
   if [ -f $lockFile ]; then
 	   echo "Timeout ERROR rv=$rv, so cleanup" |tee -a $outf $miglog 
       kill $pids
 	   rm -rf /backups/migration_nt_db $lockFile 2>>$outf
   fi
   grep 'Migration ran in' $miglog  >>$outf 2>/dev/null
   grep -B3 -A1 ERROR $miglog >>$outf
   if [ $rv -ne 0 ]; then
 	   echo "Error $rv from migrate_nt2db.sh" |tee -a $outf $miglog 
   else
	   echo "Completed migrate_nt2db on `date`" |tee -a $outf
   fi
   if (( (lockBits & 0x1) != 0 )); then
       $metautil --lock >> $miglog 2>&1
   fi
   upload_log $miglog
   cat $outf >>$instlog
   rm -f $outf
else 
   val=`$bputil -g fileDedup MetadataGeneration 0 $BPDIR/bpinit/master.ini`
   if [ $val -eq 1 ]; then
      tail -n1 $estlog >>$instlog
      upload_log $estlog
   fi
fi
exit 0
